#ifndef __MAIN_H__
#define __MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include <wiringPi.h>
#include "gpio_pwm.h"
#include "gpio_pwm_2.h"
#include "ip.h"
#include "mqtt.h"
#include "delay.h"
#include "opensh.h"
#include "INA226.h"
#include "pthrpoll.h"




#define filename "/home/orangepi/car/master/Deviceld.txt"
pthread_t thread[4];
char buffer[30]; // 用于存储文件内容

//开启线程
int thread_start(void *AppExit(void *arg),void *Mqttbeat(void *arg),void *opensh(void *arg),void *Mqtt_onnect(void *arg)){
    if(pthread_create(&thread[0],NULL,AppExit,NULL)!=0) {
        perror("Failed to create thread 0");
        return 0;
    }
    if(pthread_create(&thread[1],NULL,Mqttbeat,NULL)!=0) {
        perror("Failed to create thread 1");
        return 1;
    }
    if(pthread_create(&thread[2],NULL,opensh,NULL)!=0){
        perror("Failed to create thread 2");
        return 2;
    }
    if(pthread_create(&thread[3],NULL,Mqtt_onnect,NULL)!=0) {
        perror("Failed to create thread 3");
        return 3;
    }
        return 10086;
}


void *AppExit(void *arg){ //出现意外自动停止
    while(1){    
        Delay_Ms(0,100);
        gPwmCount++;
        if(gPwmCount>=5) {
            if(AppExit_pin_pwm==1) {//车异常问题处理
                midde_pwm();
                pin_all_default();
            }
            if(AppExit_pin_pwm==2) {//坦克异常问题处理
                midde_pwm();
                pin_all_default();
                digitalWrite(2, LOW);
                digitalWrite(21, LOW);
            } 
            if(AppExit_pin_pwm==3) {//船异常问题处理
                ship_stop_pwm();
                pin_all_ship_default();
            }
            gPwmCount=6;
        } 
    }
    return NULL; 
}

void *Mqttbeat(void *arg) { 
    printf("Mqttbeat start\n");
    Delay_Ms(15,0);
    while(1) {
        ipaddr();//获取ip
        Delay_Ms(3,0);
        mqtt_wirte();//心跳，3s一个        
    }
    return NULL;
}

void *opensh(void *arg) { 
    Delay_Ms(5,0);
    printf("open cam\n");
    opencamsh();//10s后打开游览器并且进入网址
    return NULL; 
}

void *Mqtt_onnect(void *arg) {//mqtt异常处理，断开自动重连，简单粗暴
    Delay_Ms(5,0);
    mqtt_init();//mqtt初始化
    mqtt_create(mosq);//创建mqtt客户端
    while(1){
        mqtt_create(mosq);//创建mqtt客户端     
        mqtt_cycle(mosq); //进入mqtt死循环，异常退出继续执行while
    }
    mqtt_clean(mosq);
    return NULL;
}

char *device_inspect() {//读出文件函数
    FILE *file;
    while (1) {
        file = fopen(filename, "r"); // 以只读模式打开文件

        if (file == NULL) {
            printf("文件 %s 打开失败，等待中...\n", filename);
        } 
        else {
            // 尝试读取文件内容
            if (fgets(buffer, sizeof(buffer), file) != NULL) {
                // 如果文件内容不为空
                fclose(file);
                printf("读取到文件内容: %s\n", buffer);
                return  buffer;
            } else {
                printf("文件为空，等待中...\n");
            }
            fclose(file);
        }
    Delay_Ms(1,0); // 等待1秒后再次检查
    }
}


// 等待线程结束
void thread_end() {
    pthread_join(thread[0], NULL);
    pthread_join(thread[1], NULL);
    pthread_join(thread[2], NULL);
    pthread_join(thread[3], NULL);
}

#endif